/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(G2IPMSG_CRYPTOCOMMON_H)
#define G2IPMSG_CRYPTOCOMMON_H
#if defined(USE_OPENSSL)
#include <sys/types.h>
#include <glib.h>
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include "ipmsg.h"
#include "pubcrypt.h"
#include "symcrypt.h"
#include "pbkdf2.h"
#include "base64.h"
#define G2IPMSG_CRYPTO_CAP    (RSA_CAPS|SIGN_CAPS|SYM_CAPS)
#define CRYPT_RND_MAX_RETRY 100
#define G2IPMSG_KEY_DIR                 ".g2ipmsg"
int add_timing_entropy(void);
int generate_rand(unsigned char *buf,size_t len);
int ipmsg_encrypt_message(const char *peer_addr,const char *message,unsigned char **ret_str,size_t *len);
int ipmsg_decrypt_message(const char *peer_addr,const char *message,unsigned char **ret_str,size_t *len);
GtkWidget *internal_create_crypt_config_window(void);
int apply_crypt_config_window(GtkWindow *window);
#else
#define G2IPMSG_CRYPTO_CAP    (0)
#endif  /*  USE_OPENSSL */
/* Common part */
#define get_symkey_part(x) ( (x) & (SYM_CAPS) )
#define get_asymkey_part(x) ( (x) & (RSA_CAPS) )
#define get_sign_part(x) ( (x) & (SIGN_CAPS) )
#define PUBKEY_WAIT_MICRO_SEC (1000UL*1000UL) /* 1000 msec */
#define PUBKEY_MAX_RETRY                    5

#endif  /* IPMSG_CRYPTOCOMMON_H */
