/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(MESSAGE_H)
#define MESSAGE_H
#include "common.h"
#include "callbacks.h"
#include "support.h"

#define IPMSG_MSG_MAGIC 0x20061123
#define NAME_LEN 32
typedef struct _msg_data{
  int magic;
  int version;
  int pkt_seq_no;
  int command;
  int command_opts;
  char *username;
  char *hostname;
  char *extstring;
  struct timeval tv;
  char *message;
}msg_data_t;

const char *refer_user_name_from_msg(const msg_data_t *msg);
const char *refer_host_name_from_msg(const msg_data_t *msg);
const char *refer_group_name_from_msg(const msg_data_t *msg);
const char *refer_nick_name_from_msg(const msg_data_t *msg);
int refer_pkt_no_name_from_msg(const msg_data_t *msg);
int init_message_data(msg_data_t *msg);
int release_message_data(msg_data_t *msg);
int parse_message(const char *ipaddr,msg_data_t *msg,const char *message_buff,size_t len);
#endif
