/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(MSG_INFO_H)
#define MSG_INFO_H
#include "udp.h"
#include <glib.h>
#define MSG_INFO_MAX_RETRY  5
#define MSG_INFO_RETRY_INTERVAL (5*1000) /* 5秒 */
typedef struct _message_info{
  udp_con_t *con;
  int  seq_no;         /* パケット番号  */
  gchar *ipaddr;        /*  送信先アドレスのコピー  */
  gchar *ed_msg_string; /*  外部形式で表した送信伝文(のコピー)  */
  size_t len;
  int  retry_remains;  /*  残回数  */
  gboolean first;
}message_info_t;
typedef struct _send_info{
  char *msg;
  int flags;
  GtkWidget *attachment_editor;
}send_info_t;
int register_sent_message(const udp_con_t *con,const char *ipaddr,int pktno,const char *message,size_t len);
int unregister_sent_message(int pktno);
int retry_messages_once(void);
int init_message_info_manager(void);
#endif /*  MSG_INFO_H */
