/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(MSGOUT_H)
#define MSGOUT_H

//#define DEBUG 1
#if defined(DEBUG)
#define dbg_out(fmt,arg...) do{                                         \
    fprintf(stderr, "[file:%s function: %s line:%d ] " fmt,__FILE__,__FUNCTION__,__LINE__,##arg); \
    syslog(LOG_INFO|LOG_USER, "[file:%s function: %s line:%d ] " fmt,__FILE__,__FUNCTION__,__LINE__,##arg); \
    fflush(stderr);              \
  }while(0)
#else
#define dbg_out(fmt,arg...) do{         \
    if (hostinfo_refer_debug_state()){	\
      fprintf(stderr, "[file:%s function: %s line:%d ] " fmt,__FILE__,__FUNCTION__,__LINE__,##arg); \
      syslog(LOG_INFO|LOG_USER, "[file:%s function: %s line:%d ] " fmt,__FILE__,__FUNCTION__,__LINE__,##arg); \
      fflush(stderr);							\
    }                            \
  }while(0)      
#endif
#define war_out(fmt,arg...) do{                                         \
    fprintf(stderr, "Warning : [file:%s line:%d ] " fmt,__FILE__,__LINE__,##arg);	\
    fflush(stderr);              \
    syslog(LOG_WARNING|LOG_USER, "[file:%s function: %s line:%d ] " fmt,__FILE__,__FUNCTION__,__LINE__,##arg); \
  }while(0)
#define err_out(fmt,arg...) do{                                         \
    fprintf(stderr, "Error : [file:%s line:%d ] " fmt,__FILE__,__LINE__,##arg);	\
    fflush(stderr);              \
    syslog(LOG_ERR|LOG_USER, "[file:%s function: %s line:%d ] " fmt,__FILE__,__FUNCTION__,__LINE__,##arg); \
  }while(0)

#define _assert(cond) do{                                                   \
  if (!(cond)) {                                                            \
     fprintf(stderr, "Assertion : [file:%s line:%d ]\n",__FILE__,__LINE__); \
     fflush(stderr);                                                        \
     abort();								    \
    }                                                                       \
  }while(0)

#endif
