/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(PRIVATE_H)
#define PRIVATE_H
#define IPMSG_PRIVATE_DATA_MAGIC 0x19731219
#define IPMSG_PRIVATE_NO_TYPE 0
#define IPMSG_PRIVATE_RECVMSG 1
#define IPMSG_PRIVATE_AFCB    2
typedef struct _ipmsg_private_data{
  int magic;
  int type;
  void *data;
}ipmsg_private_data_t;

typedef struct _ipmsg_recvmsg_private{
  char *ipaddr;
  int   pktno;
  int   flags;
  char *ext_part;
}ipmsg_recvmsg_private_t;

#define IPMSG_ASSERT_PRIVATE(private,ptype) do{			 \
    g_assert((private));					 \
    g_assert((private)->magic == IPMSG_PRIVATE_DATA_MAGIC);	 \
    g_assert((private)->type == (ptype));			 \
  }while(0)

#define IPMSG_HOOKUP_DATA(component,data_p,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    data_p, (GDestroyNotify) destroy_ipmsg_private)

int init_ipmsg_private(ipmsg_private_data_t **priv,const int type);
int init_recvmsg_private(const char *ipaddr,int flags,int pktno, ipmsg_private_data_t **priv);
void destroy_ipmsg_private(gpointer data);

#endif
