/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(PROTOCOL_H)
#define PROTOCOL_H
#include "udp.h"
long ipmsg_get_pkt_no(void);
int ipmsg_send_release_files(const udp_con_t *con,const char *ipaddr,int pktno);
int ipmsg_send_br_isgetlist2(const udp_con_t *con,const int flags);
int ipmsg_send_br_entry(const udp_con_t *con,const int flags);
int ipmsg_send_ans_entry(const udp_con_t *con,const int flags);
int ipmsg_send_br_exit(const udp_con_t *con,const int flags);
int ipmsg_proc_br_absence(const udp_con_t *con,const msg_data_t *msg);
int ipmsg_send_br_absence(const udp_con_t *con,const int flags);
int ipmsg_send_recv_msg(const udp_con_t *con,const msg_data_t *orig_msg);
int ipmsg_send_read_msg(const udp_con_t *con,const char *ipaddr,int pktno);
int ipmsg_send_send_msg(const udp_con_t *con,const char *ipaddr,int flags,int pktno,const char *message,const char *ext_part);
int ipmsg_dispatch_message(const udp_con_t *con,const msg_data_t *msg);
int ipmsg_construct_getfile_message(unsigned long ftype,const char *msg_string,int flags,size_t *len,char **msg,long pktno);
int ipmsg_send_broad_cast(const udp_con_t *con,const char *msg,size_t len);
int ipmsg_send_get_info_msg(const udp_con_t *con,const char *ipaddr,unsigned long command);
int ipmsg_send_getpubkey(const udp_con_t *con,const char *ipaddr);
#endif
