/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(G2IPMSG_SYMCRYPT_H)
#define G2IPMSG_SYMCRYPT_H
#include <openssl/evp.h>
#define SYMCRYPT_MAX_KEY_TYPE 5

#define RC2_CAPS            (IPMSG_RC2_40|IPMSG_RC2_128|IPMSG_RC2_256)
#define BLOWFISH_CAPS       (IPMSG_BLOWFISH_128|IPMSG_BLOWFISH_256)
#define SYM_CAPS            (RC2_CAPS|BLOWFISH_CAPS)
int ipmsg_get_skey_length(unsigned long type,size_t *ret_len);
int blowfish_cbc_encrypt_setup(const char *key,size_t key_len_byte,const char *iv,EVP_CIPHER_CTX **ret);
int blowfish_cbc_decrypt_setup(const char *key,size_t key_len_byte,const char *iv,EVP_CIPHER_CTX **ret);
int rc2_cbc_encrypt_setup(const char *key,size_t key_len_byte,const char *iv,EVP_CIPHER_CTX **ret);
int rc2_cbc_decrypt_setup(const char *key,size_t key_len_byte,const char *iv,EVP_CIPHER_CTX **ret);
int common_cbc_encrypt(EVP_CIPHER_CTX *ctx, const char *data, int inl, int *rb,char **ret_buff);
int common_cbc_decrypt(EVP_CIPHER_CTX *ctx, const char *ct, int inl,char **ret_buff,size_t *outl);
int common_cbc_finalize(EVP_CIPHER_CTX **ctx_p);
int symcrypt_encrypt_message(unsigned long type,const unsigned char *plain,
			 char **key_p, size_t *key_len_p,char **enc_p,
			     size_t *enc_len_p);
int symcrypt_decrypt_message(unsigned long type,const unsigned char *encoded,
			     size_t enc_len, const char *key,char **dec_p,size_t *dec_len_p);
int select_symmetric_key(unsigned long peer_cap,unsigned long *selected_key,int speed);
#endif  /*  G2IPMSG_SYMCRYPT_H  */
