/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(IPMSG_TCP_H)
#include <signal.h>
#define IPMSG_TCP_H
#define TCP_LISTEN_LEN 5
#define TCP_DOWNLOAD_RETRY 200
#define TCP_FLUSH_RETRY    10
#define TCP_SELECT_SEC 1
#define TCP_CLIENT_TMOUT_MS  500
#define TCP_CLOSE_WAIT_SEC 5
#define TCP_FILE_BUFSIZ 4096
typedef struct _tcp_con{
  int soc;
  int family;
  struct addrinfo *self;
}tcp_con_t;
typedef struct _request_msg{
  long pkt_no;
  int fileid;
  int offset;
}request_msg_t;
typedef struct _tcp_dsend_pkt{
  tcp_con_t *con;
  char *topdir;
}tcp_dsend_pkt_t;

gpointer ipmsg_tcp_server_thread(gpointer data);
int tcp_enable_keepalive(const tcp_con_t *con);
int tcp_setup_client(int family,const char *ipaddr,int port,tcp_con_t *con);
int tcp_flush_buffer(tcp_con_t *con);
int tcp_set_ipmsg_bufsiz(int soc);
int disable_pipe_signal(struct sigaction *saved_act);
int enable_pipe_signal(struct sigaction *saved_act);
#endif /* IPMSG_TCP_H */
