/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(UDP_H)
#define UDP_H
#include <sys/socket.h>
#include <netdb.h>

typedef struct _udp_con{
  int soc;
  int family;
  int port;
  char peer[NI_MAXHOST];
  struct addrinfo *client_info;
  struct addrinfo *server_info;
}udp_con_t;
int internal_realloc(void **ptr,size_t new_size,size_t old_size);

int udp_setup_client(udp_con_t *con,const char *hostname, int port,int family);
int udp_setup_server(udp_con_t *con,int port,int family);
int udp_send_message(const udp_con_t *con,const char *ipaddr,int port, const char *msg,size_t len);
int udp_send_peer(const udp_con_t *con,const char *msg,size_t len);
int udp_send_broadcast_with_addr(const udp_con_t *con,const char *bcast,const char *msg,size_t len);
int udp_send_broadcast(const udp_con_t *con,const char *msg,size_t len);
int udp_enable_broadcast(const udp_con_t *con);
int udp_disable_broadcast(const udp_con_t *con);
int udp_recv_message(const udp_con_t *con,char **msg,size_t *len);
const char *udp_get_peeraddr(const udp_con_t *con);
int udp_release_connection(udp_con_t *con);
#endif
