/*
 *  Copyright (C) 2006 Takeharu KATO
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <glib.h>
#include "common.h"
GStaticMutex serialize_mutex = G_STATIC_MUTEX_INIT;
int
get_envval(const char *var,char **val_p) {
  char *val;
  char *val_str;
  int rc;

  if ( (!var) || (!val_p) ) 
    return -EINVAL;

  g_static_mutex_lock(&serialize_mutex); /* ただの気休めに過ぎないが, 一応排他 */
  rc=-ENOENT;
  val=getenv(var);
  if (!val)
    goto unlock_out;

  val_str=strdup(val);

  rc=-ENOMEM;
  if (!val_str)
    goto unlock_out;

  *val_p=val_str;
  rc=0;

 unlock_out:
  g_static_mutex_unlock(&serialize_mutex);
  return rc;
}
